OpenJPEG: sparse_array.c File Reference

OpenJPEG 2.3.1

Data Structures | Functions
sparse_array.c File Reference
`#include "opj_includes.h"`

## Data Structures
struct | opj_sparse_array_int32

## Functions
opj_sparse_array_int32_t * | opj_sparse_array_int32_create (OPJ_UINT32 width, OPJ_UINT32 height, OPJ_UINT32 block_width, OPJ_UINT32 block_height)
| Creates a new sparse array. More...
void | opj_sparse_array_int32_free (opj_sparse_array_int32_t *sa)
| Frees a sparse array. More...
OPJ_BOOL | opj_sparse_array_is_region_valid (const opj_sparse_array_int32_t *sa, OPJ_UINT32 x0, OPJ_UINT32 y0, OPJ_UINT32 x1, OPJ_UINT32 y1)
| Returns whether region bounds are valid (non empty and within array bounds) More...
static OPJ_BOOL | opj_sparse_array_int32_read_or_write (const opj_sparse_array_int32_t *sa, OPJ_UINT32 x0, OPJ_UINT32 y0, OPJ_UINT32 x1, OPJ_UINT32 y1, OPJ_INT32 *buf, OPJ_UINT32 buf_col_stride, OPJ_UINT32 buf_line_stride, OPJ_BOOL forgiving, OPJ_BOOL is_read_op)
OPJ_BOOL | opj_sparse_array_int32_read (const opj_sparse_array_int32_t *sa, OPJ_UINT32 x0, OPJ_UINT32 y0, OPJ_UINT32 x1, OPJ_UINT32 y1, OPJ_INT32 *dest, OPJ_UINT32 dest_col_stride, OPJ_UINT32 dest_line_stride, OPJ_BOOL forgiving)
| Read the content of a rectangular region of the sparse array into a user buffer. More...
OPJ_BOOL | opj_sparse_array_int32_write (opj_sparse_array_int32_t *sa, OPJ_UINT32 x0, OPJ_UINT32 y0, OPJ_UINT32 x1, OPJ_UINT32 y1, const OPJ_INT32 *src, OPJ_UINT32 src_col_stride, OPJ_UINT32 src_line_stride, OPJ_BOOL forgiving)
| Write the content of a rectangular region into the sparse array from a user buffer. More...

## Function Documentation

## ◆ opj_sparse_array_int32_read_or_write()

static OPJ_BOOL opj_sparse_array_int32_read_or_write | ( | const opj_sparse_array_int32_t * | sa,
|  | OPJ_UINT32 | x0,
|  | OPJ_UINT32 | y0,
|  | OPJ_UINT32 | x1,
|  | OPJ_UINT32 | y1,
|  | OPJ_INT32 * | buf,
|  | OPJ_UINT32 | buf_col_stride,
|  | OPJ_UINT32 | buf_line_stride,
|  | OPJ_BOOL | forgiving,
|  | OPJ_BOOL | is_read_op
| ) |  |
| static

References opj_sparse_array_int32::block_count_hor, opj_sparse_array_int32::block_height, opj_sparse_array_int32::block_width, opj_sparse_array_int32::data_blocks, opj_calloc(), OPJ_FALSE, OPJ_RESTRICT, opj_sparse_array_is_region_valid(), OPJ_TRUE, and opj_uint_min().

Referenced by opj_sparse_array_int32_read(), and opj_sparse_array_int32_write().